{

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   Copyrightcillas 1.0.3                                         *
    *   Copyright  2004  Florian Oldach <oldach@hartwork.org>        *
    *                     Sebastian Pipping <pipping@hartwork.org>    *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2004-09-01   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

}

PROGRAM mapgen;

USES
  crt, crc_std;

VAR
  MyMap : tMapEx;
  MyFile : tFileMap;
  x, y : BYTE;


{ -------------------------------------------------------------------------------------------------------- set_xy ----- }
PROCEDURE set_xy( x, y : BYTE; ch : CHAR; VAR MyMap : tMap );

  {
    get two points and a symbol and write this in MyMap. This symbol will be printed on screen at the given points.
    the procedure member checks if a given point is possible.
  }

  BEGIN
    IF member( x, y ) THEN
      MyMap[ x, y ] := ch;

  END;


{ ---------------------------------------------------------------------------------------------------- frame_rect ----- }
PROCEDURE frame_rect( x1, y1, x2, y2 : BYTE; VAR MyMap : tMap );

  {
  	x2 must be greater than x1 and y2 must be greater than y1.
  	This "paints" a square frame on the map with the points x1/y1 right-top and x2/y2 left-bottom.
  }

  VAR
    i : BYTE;

  BEGIN

    { Head }
    set_xy( x1, y1, ASCII_DOUBLE_CORNER_ES, MyMap );
    FOR i := x1 + 1 TO x2 - 1 DO
      set_xy( i, y1, ASCII_DOUBLE_LINE_HORZ, MyMap );

    set_xy( x2, y1, ASCII_DOUBLE_CORNER_SW, MyMap );

    { Body }
    FOR i := y1 + 1 TO y2 - 1 DO
      BEGIN
        set_xy( x1, i, ASCII_DOUBLE_LINE_VERT, MyMap );
        set_xy( x2, i, ASCII_DOUBLE_LINE_VERT, MyMap );

      END;

    { Foot }
    set_xy( x1, y2, ASCII_DOUBLE_CORNER_NE, MyMap );
    FOR i := x1 + 1 TO x2 - 1 DO
      set_xy( i, y2, ASCII_DOUBLE_LINE_HORZ, MyMap );

    set_xy( x2, y2, ASCII_DOUBLE_CORNER_WN, MyMap );

  END;


{ ----------------------------------------------------------------------------------------------------- fill_rect ----- }
PROCEDURE fill_rect( x1, y1, x2, y2 : BYTE; ch : CHAR; VAR MyMap : tMap );

  {
  	x2 must be greater than x1 and y2 must be greater than y1.
    This "paints" a square frame of symbols on the map with the points x1/y1 right-top and x2/y2 left-bottom.
    Used to fill frames created with frame_rect.
  }

  VAR
    x, y : BYTE;
  BEGIN
    FOR x := x1 TO x2 DO
      BEGIN
        FOR y := y1 TO y2 DO
          set_xy( x, y, ch, MyMap );

      END;

  END;

BEGIN
  ASSIGN( MyFile, FILE_MAPS );
  REWRITE( MyFile );


{ -------------------------------------------------------------------------------------------- MAP 01 - 'CLASSIC' ----- }

  {
      MyMap.Routes[ a ].Start.x := 49;
      MyMap.Routes[ a ].Start.y := 34;

      Set startpoint on the map. X can be a value between 1 and 80 and y a value between 1 and 50.

      MyMap.Routes[ a ].iCorners := b;

      Set number of corners in the snake. 1 corner stands for a straight walking snake without a corner.

      MyMap.Routes[ a ].Path[ 1 to b ].iDir := DIR_LEFT;
      MyMap.Routes[ a ].Path[ 1 to b ].iDist := 15;

      iDir is the direction seen from the head the snkae lays.
      iDist is the length of the snake from head to corner or foot or corner to foot.

      MyMap.Routes[ a ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ a ].iDirFoot := DIR_LEFT;

      thats the way the snake walkes.
  }

    WITH MyMap DO
    BEGIN
      sTitle           := 'Classic';
      iInitialCookies  := 1;
      bRefreshCookies  := TRUE;

      clear_map( chMap );
      frame_rect( 1, 1, 80, 49, chMap );


    { 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 48;
      MyMap.Routes[ 1 ].Start.y := 25;
      MyMap.Routes[ 1 ].iCorners := 1;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 1 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 1 ].iDirFoot := DIR_LEFT;


	{ 2 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 2 ].Start.x := 48;
      MyMap.Routes[ 2 ].Start.y := 22;
      MyMap.Routes[ 2 ].iCorners := 1;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 2 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 2 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 3 ].Start.x := 33;
      MyMap.Routes[ 3 ].Start.y := 28;
      MyMap.Routes[ 3 ].iCorners := 1;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 3 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 3 ].iDirFoot := DIR_RIGHT;


	{ 3 PLAYERS - INIT THREE SNAKES }
      MyMap.Routes[ 4 ].Start.x := 48;
      MyMap.Routes[ 4 ].Start.y := 25;
      MyMap.Routes[ 4 ].iCorners := 1;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 4 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 4 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 5 ].Start.x := 33;
      MyMap.Routes[ 5 ].Start.y := 31;
      MyMap.Routes[ 5 ].iCorners := 1;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 5 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 5 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 6 ].Start.x := 33;
      MyMap.Routes[ 6 ].Start.y := 19;
      MyMap.Routes[ 6 ].iCorners := 1;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 6 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 48;
      MyMap.Routes[ 7 ].Start.y := 22;
      MyMap.Routes[ 7 ].iCorners := 1;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 7 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 7 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 8 ].Start.x := 33;
      MyMap.Routes[ 8 ].Start.y := 28;
      MyMap.Routes[ 8 ].iCorners := 1;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 8 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 8 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 9 ].Start.x := 33;
      MyMap.Routes[ 9 ].Start.y := 16;
      MyMap.Routes[ 9 ].iCorners := 1;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 9 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 48;
      MyMap.Routes[ 10 ].Start.y := 34;
      MyMap.Routes[ 10 ].iCorners := 1;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 10 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 10 ].iDirFoot := DIR_LEFT;

    END;
  WRITE( MyFile, MyMap );


{ ---------------------------------------------------------------------------------------- MAP 02 - 'EMPTY SPACE' ----- }
  WITH MyMap DO { FAIR }
    BEGIN
      sTitle           := 'Empty Space';
      iInitialCookies  := 4;
      bRefreshCookies  := TRUE;

      clear_map( chMap );


	{ 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 48;
      MyMap.Routes[ 1 ].Start.y := 25;
      MyMap.Routes[ 1 ].iCorners := 1;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 1 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 1 ].iDirFoot := DIR_LEFT;


	{ 2 PLAYERS - INIT TWO SNAKES}
      MyMap.Routes[ 2 ].Start.x := 48;
      MyMap.Routes[ 2 ].Start.y := 22;
      MyMap.Routes[ 2 ].iCorners := 1;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 2 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 2 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 3 ].Start.x := 33;
      MyMap.Routes[ 3 ].Start.y := 28;
      MyMap.Routes[ 3 ].iCorners := 1;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 3 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 3 ].iDirFoot := DIR_RIGHT;


	{ 3 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 4 ].Start.x := 48;
      MyMap.Routes[ 4 ].Start.y := 25;
      MyMap.Routes[ 4 ].iCorners := 1;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 4 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 4 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 5 ].Start.x := 33;
      MyMap.Routes[ 5 ].Start.y := 31;
      MyMap.Routes[ 5 ].iCorners := 1;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 5 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 5 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 6 ].Start.x := 33;
      MyMap.Routes[ 6 ].Start.y := 19;
      MyMap.Routes[ 6 ].iCorners := 1;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 6 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 48;
      MyMap.Routes[ 7 ].Start.y := 22;
      MyMap.Routes[ 7 ].iCorners := 1;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 7 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 7 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 8 ].Start.x := 33;
      MyMap.Routes[ 8 ].Start.y := 28;
      MyMap.Routes[ 8 ].iCorners := 1;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 8 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 8 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 9 ].Start.x := 33;
      MyMap.Routes[ 9 ].Start.y := 16;
      MyMap.Routes[ 9 ].iCorners := 1;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 9 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 48;
      MyMap.Routes[ 10 ].Start.y := 34;
      MyMap.Routes[ 10 ].iCorners := 1;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 10 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 10 ].iDirFoot := DIR_LEFT;

    END;
  WRITE( MyFile, MyMap );


{ ----------------------------------------------------------------------------------------- MAP 03 - 'HALFTOWERS' ----- }
  WITH MyMap DO
    BEGIN
      sTitle           := 'Halftowers';
      iInitialCookies  := 4;
      bRefreshCookies  := TRUE;

      clear_map( chMap );

	{ PAINT FRAMES }
      frame_rect( 21, 0, 35, 10, chMap );
      fill_rect( 22, 1, 34, 9, ASCII_CIRCLE, chMap );

      frame_rect( 46, 0, 60, 15, chMap );
      fill_rect( 47, 1, 59, 14, ASCII_CIRCLE, chMap );

      frame_rect( 21, 35, 35, 50, chMap );
      fill_rect( 22, 36, 34, 49, ASCII_CIRCLE, chMap );

      frame_rect( 46, 40, 60, 50, chMap );
      fill_rect( 47, 41, 59, 49, ASCII_CIRCLE, chMap );


	{ 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 48;
      MyMap.Routes[ 1 ].Start.y := 25;
      MyMap.Routes[ 1 ].iCorners := 1;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 1 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 1 ].iDirFoot := DIR_LEFT;


	{ 2 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 2 ].Start.x := 48;
      MyMap.Routes[ 2 ].Start.y := 22;
      MyMap.Routes[ 2 ].iCorners := 1;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 2 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 2 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 3 ].Start.x := 33;
      MyMap.Routes[ 3 ].Start.y := 28;
      MyMap.Routes[ 3 ].iCorners := 1;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 3 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 3 ].iDirFoot := DIR_RIGHT;


	{ 3 PLAYERS - INIT THREE SNAKES }
      MyMap.Routes[ 4 ].Start.x := 48;
      MyMap.Routes[ 4 ].Start.y := 25;
      MyMap.Routes[ 4 ].iCorners := 1;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 4 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 4 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 5 ].Start.x := 33;
      MyMap.Routes[ 5 ].Start.y := 31;
      MyMap.Routes[ 5 ].iCorners := 1;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 5 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 5 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 6 ].Start.x := 33;
      MyMap.Routes[ 6 ].Start.y := 19;
      MyMap.Routes[ 6 ].iCorners := 1;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 6 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 48;
      MyMap.Routes[ 7 ].Start.y := 22;
      MyMap.Routes[ 7 ].iCorners := 1;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 7 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 7 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 8 ].Start.x := 33;
      MyMap.Routes[ 8 ].Start.y := 28;
      MyMap.Routes[ 8 ].iCorners := 1;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 8 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 8 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 9 ].Start.x := 33;
      MyMap.Routes[ 9 ].Start.y := 16;
      MyMap.Routes[ 9 ].iCorners := 1;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 9 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 48;
      MyMap.Routes[ 10 ].Start.y := 34;
      MyMap.Routes[ 10 ].iCorners := 1;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 10 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 10 ].iDirFoot := DIR_LEFT;

    END;
  WRITE( MyFile, MyMap );


{ ------------------------------------------------------------------------------------------- MAP 04 - 'THE CAGE' ----- }
  WITH MyMap DO
    BEGIN
      sTitle           := 'The Cage';
      iInitialCookies  := 4;
      bRefreshCookies  := TRUE;

      clear_map( chMap );

    { PAINT FARME }
      fill_rect( 1, 1, 80, 49, ASCII_CIRCLE, chMap );

      frame_rect( 4, 3, 77, 47, chMap );
      fill_rect( 5, 4, 76, 46, ASCII_SPACE, chMap );


      { left }
      frame_rect( 0, 20, 4, 30, chMap );
      fill_rect( 1, 21, 4, 29, ASCII_SPACE, chMap );
      set_xy( 4, 20, ASCII_DOUBLE_CORNER_WN, chMap );
      set_xy( 4, 30, ASCII_DOUBLE_CORNER_SW, chMap );

      { right }
      frame_rect( 77, 20, 81, 30, chMap );
      fill_rect( 77, 21, 80, 29, ASCII_SPACE, chMap );
      set_xy( 77, 20, ASCII_DOUBLE_CORNER_NE, chMap );
      set_xy( 77, 30, ASCII_DOUBLE_CORNER_ES, chMap );

      { top }
      frame_rect( 34, 0, 47, 3, chMap );
      fill_rect( 35, 1, 46, 3, ASCII_SPACE, chMap );
      set_xy( 34, 3, ASCII_DOUBLE_CORNER_WN, chMap );
      set_xy( 47, 3, ASCII_DOUBLE_CORNER_NE, chMap );

      { bottom }
      frame_rect( 34, 47, 47, 50, chMap );
      fill_rect( 35, 47, 46, 49, ASCII_SPACE, chMap );
      set_xy( 34, 47, ASCII_DOUBLE_CORNER_SW, chMap );
      set_xy( 47, 47, ASCII_DOUBLE_CORNER_ES, chMap );


	{ 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 48;
      MyMap.Routes[ 1 ].Start.y := 25;
      MyMap.Routes[ 1 ].iCorners := 1;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 1 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 1 ].iDirFoot := DIR_LEFT;


	{ 2 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 2 ].Start.x := 48;
      MyMap.Routes[ 2 ].Start.y := 22;
      MyMap.Routes[ 2 ].iCorners := 1;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 2 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 2 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 3 ].Start.x := 33;
      MyMap.Routes[ 3 ].Start.y := 28;
      MyMap.Routes[ 3 ].iCorners := 1;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 3 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 3 ].iDirFoot := DIR_RIGHT;


	{ 3 PLAYERS - INIT THREE SNAKES }
      MyMap.Routes[ 4 ].Start.x := 48;
      MyMap.Routes[ 4 ].Start.y := 25;
      MyMap.Routes[ 4 ].iCorners := 1;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 4 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 4 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 5 ].Start.x := 33;
      MyMap.Routes[ 5 ].Start.y := 31;
      MyMap.Routes[ 5 ].iCorners := 1;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 5 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 5 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 6 ].Start.x := 33;
      MyMap.Routes[ 6 ].Start.y := 19;
      MyMap.Routes[ 6 ].iCorners := 1;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 6 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 48;
      MyMap.Routes[ 7 ].Start.y := 22;
      MyMap.Routes[ 7 ].iCorners := 1;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 7 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 7 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 8 ].Start.x := 33;
      MyMap.Routes[ 8 ].Start.y := 28;
      MyMap.Routes[ 8 ].iCorners := 1;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 8 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 8 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 9 ].Start.x := 33;
      MyMap.Routes[ 9 ].Start.y := 16;
      MyMap.Routes[ 9 ].iCorners := 1;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 9 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 48;
      MyMap.Routes[ 10 ].Start.y := 34;
      MyMap.Routes[ 10 ].iCorners := 1;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 10 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 10 ].iDirFoot := DIR_LEFT;

    END;
  WRITE( MyFile, MyMap );


{ ----------------------------------------------------------------------------------------- MAP 05 - 'NINE BOXES' ----- }
  WITH MyMap DO
    BEGIN
      sTitle           := 'Nine Boxes';
      iInitialCookies  := 4;
      bRefreshCookies  := TRUE;

      clear_map( chMap );

    { PAINT FRAME }

	  { left }
      frame_rect( 18, 7, 25, 11, chMap );
      fill_rect( 19, 8, 24, 10, ASCII_CIRCLE, chMap );

      frame_rect( 18, 23, 25, 27, chMap );
      fill_rect( 19, 24, 24, 26, ASCII_CIRCLE, chMap );

      frame_rect( 18, 39, 25, 43, chMap );
      fill_rect( 19, 40, 24, 42, ASCII_CIRCLE, chMap );

      { middle }
      frame_rect( 37, 7, 44, 11, chMap );
      fill_rect( 38, 8, 43, 10, ASCII_CIRCLE, chMap );

      frame_rect( 37, 23, 44, 27, chMap );
      fill_rect( 38, 24, 43, 26, ASCII_CIRCLE, chMap );

      frame_rect( 37, 39, 44, 43, chMap );
      fill_rect( 38, 40, 43, 42, ASCII_CIRCLE, chMap );

      { right }
      frame_rect( 56, 7, 63, 11, chMap );
      fill_rect( 57, 8, 62, 10, ASCII_CIRCLE, chMap );

      frame_rect( 56, 23, 63, 27, chMap );
      fill_rect( 57, 24, 62, 26, ASCII_CIRCLE, chMap );

      frame_rect( 56, 39, 63, 43, chMap );
      fill_rect( 57, 40, 62, 42, ASCII_CIRCLE, chMap );


	{ 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 54;
      MyMap.Routes[ 1 ].Start.y := 45;
      MyMap.Routes[ 1 ].iCorners := 2;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 1 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 1 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 1 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 1 ].iDirFoot := DIR_UP;


	{ 2 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 2 ].Start.x := 54;
      MyMap.Routes[ 2 ].Start.y := 45;
      MyMap.Routes[ 2 ].iCorners := 2;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 2 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 2 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 2 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 2 ].iDirFoot := DIR_UP;

      MyMap.Routes[ 3 ].Start.x := 27;
      MyMap.Routes[ 3 ].Start.y := 5;
      MyMap.Routes[ 3 ].iCorners := 2;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 3 ].Path[ 2 ].iDir := DIR_DOWN;
      MyMap.Routes[ 3 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 3 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 3 ].iDirFoot := DIR_DOWN;


	{ 3 PLAYERS - INIT THREE SNAKES }
      MyMap.Routes[ 4 ].Start.x := 54;
      MyMap.Routes[ 4 ].Start.y := 45;
      MyMap.Routes[ 4 ].iCorners := 2;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 4 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 4 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 4 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 4 ].iDirFoot := DIR_UP;

      MyMap.Routes[ 5 ].Start.x := 27;
      MyMap.Routes[ 5 ].Start.y := 5;
      MyMap.Routes[ 5 ].iCorners := 2;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 5 ].Path[ 2 ].iDir := DIR_DOWN;
      MyMap.Routes[ 5 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 5 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 5 ].iDirFoot := DIR_DOWN;

      MyMap.Routes[ 6 ].Start.x := 16;
      MyMap.Routes[ 6 ].Start.y := 37;
      MyMap.Routes[ 6 ].iCorners := 2;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 6 ].Path[ 2 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 2 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 6 ].iDirHead := DIR_UP;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 54;
      MyMap.Routes[ 7 ].Start.y := 45;
      MyMap.Routes[ 7 ].iCorners := 2;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 7 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 7 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 7 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 7 ].iDirFoot := DIR_UP;

      MyMap.Routes[ 8 ].Start.x := 27;
      MyMap.Routes[ 8 ].Start.y := 5;
      MyMap.Routes[ 8 ].iCorners := 2;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 8 ].Path[ 2 ].iDir := DIR_DOWN;
      MyMap.Routes[ 8 ].Path[ 2 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 8 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 8 ].iDirFoot := DIR_DOWN;

      MyMap.Routes[ 9 ].Start.x := 16;
      MyMap.Routes[ 9 ].Start.y := 37;
      MyMap.Routes[ 9 ].iCorners := 2;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 9 ].Path[ 2 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 2 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 9 ].iDirHead := DIR_UP;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 65;
      MyMap.Routes[ 10 ].Start.y := 13;
      MyMap.Routes[ 10 ].iCorners := 2;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 8; { 1 + 5 + 2 }
      MyMap.Routes[ 10 ].Path[ 2 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 2 ].iDist := 12; { 1 + 8 + 3 }
      MyMap.Routes[ 10 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 10 ].iDirFoot := DIR_LEFT;

    END;
  WRITE( MyFile, MyMap );


{ ---------------------------------------------------------------------------------- MAP 06 - 'BOXES IN THE CAGE' ----- }
  WITH MyMap DO
    BEGIN
      sTitle           := 'Boxes in the Cage';
      iInitialCookies  := 4;
      bRefreshCookies  := TRUE;

	  clear_map( chMap );

    { PAINT FRAMES }

	{ CAGE }

      fill_rect( 1, 1, 80, 49, ASCII_CIRCLE, chMap );

      frame_rect( 4, 3, 77, 47, chMap );
      fill_rect( 5, 4, 76, 46, ASCII_SPACE, chMap );


      { left }
      frame_rect( 0, 20, 4, 30, chMap );
      fill_rect( 1, 21, 4, 29, ASCII_SPACE, chMap );

      set_xy( 4, 20, ASCII_DOUBLE_CORNER_WN, chMap );
      set_xy( 4, 30, ASCII_DOUBLE_CORNER_SW, chMap );

      { right }
      frame_rect( 77, 20, 81, 30, chMap );
      fill_rect( 77, 21, 80, 29, ASCII_SPACE, chMap );

      set_xy( 77, 20, ASCII_DOUBLE_CORNER_NE, chMap );
      set_xy( 77, 30, ASCII_DOUBLE_CORNER_ES, chMap );

      { top }
      frame_rect( 34, 0, 47, 3, chMap );
      fill_rect( 35, 1, 46, 3, ASCII_SPACE, chMap );

      set_xy( 34, 3, ASCII_DOUBLE_CORNER_WN, chMap );
      set_xy( 47, 3, ASCII_DOUBLE_CORNER_NE, chMap );

      { bottom }
      frame_rect( 34, 47, 47, 50, chMap );
      fill_rect( 35, 47, 46, 49, ASCII_SPACE, chMap );

      set_xy( 34, 47, ASCII_DOUBLE_CORNER_SW, chMap );
      set_xy( 47, 47, ASCII_DOUBLE_CORNER_ES, chMap );


	{ BOXES }

      { left }
      frame_rect( 26, 14, 31, 18, chMap );
      fill_rect( 27, 15, 30, 17, ASCII_CIRCLE, chMap );

      frame_rect( 26, 32, 31, 36, chMap );
      fill_rect( 27, 33, 30, 35, ASCII_CIRCLE, chMap );

      { middle }
      frame_rect( 38, 23, 43, 27, chMap );
      fill_rect( 39, 24, 42, 26, ASCII_CIRCLE, chMap );

      { right }
      frame_rect( 50, 14, 55, 18, chMap );
      fill_rect( 51, 15, 54, 17, ASCII_CIRCLE, chMap );

      frame_rect( 50, 32, 55, 36, chMap );
      fill_rect( 51, 33, 54, 35, ASCII_CIRCLE, chMap );


	{ 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 36;
      MyMap.Routes[ 1 ].Start.y := 25;
      MyMap.Routes[ 1 ].iCorners := 1;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 1 ].iDirHead := DIR_UP;
      MyMap.Routes[ 1 ].iDirFoot := DIR_DOWN;


	{ 2 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 2 ].Start.x := 36;
      MyMap.Routes[ 2 ].Start.y := 25;
      MyMap.Routes[ 2 ].iCorners := 1;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 2 ].iDirHead := DIR_UP;
      MyMap.Routes[ 2 ].iDirFoot := DIR_DOWN;

      MyMap.Routes[ 3 ].Start.x := 45;
      MyMap.Routes[ 3 ].Start.y := 25;
      MyMap.Routes[ 3 ].iCorners := 1;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 15;
      MyMap.Routes[ 3 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 3 ].iDirFoot := DIR_UP;


	{ 3 PLAYERS - INIT THREE SNAKES }
      MyMap.Routes[ 4 ].Start.x := 74;
      MyMap.Routes[ 4 ].Start.y := 39;
      MyMap.Routes[ 4 ].iCorners := 2;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 4 ].Path[ 2 ].iDir := DIR_LEFT;
      MyMap.Routes[ 4 ].Path[ 2 ].iDist := 9;
      MyMap.Routes[ 4 ].iDirHead := DIR_UP;
      MyMap.Routes[ 4 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 5 ].Start.x := 65;
      MyMap.Routes[ 5 ].Start.y := 5;
      MyMap.Routes[ 5 ].iCorners := 2;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 9;
      MyMap.Routes[ 5 ].Path[ 2 ].iDir := DIR_DOWN;
      MyMap.Routes[ 5 ].Path[ 2 ].iDist := 6;
      MyMap.Routes[ 5 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 5 ].iDirFoot := DIR_DOWN;

      MyMap.Routes[ 6 ].Start.x := 7;
      MyMap.Routes[ 6 ].Start.y := 11;
      MyMap.Routes[ 6 ].iCorners := 2;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 6 ].Path[ 2 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 2 ].iDist := 9;
      MyMap.Routes[ 6 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 74;
      MyMap.Routes[ 7 ].Start.y := 39;
      MyMap.Routes[ 7 ].iCorners := 2;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 7 ].Path[ 2 ].iDir := DIR_LEFT;
      MyMap.Routes[ 7 ].Path[ 2 ].iDist := 9;
      MyMap.Routes[ 7 ].iDirHead := DIR_UP;
      MyMap.Routes[ 7 ].iDirFoot := DIR_LEFT;

      MyMap.Routes[ 8 ].Start.x := 65;
      MyMap.Routes[ 8 ].Start.y := 5;
      MyMap.Routes[ 8 ].iCorners := 2;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 9;
      MyMap.Routes[ 8 ].Path[ 2 ].iDir := DIR_DOWN;
      MyMap.Routes[ 8 ].Path[ 2 ].iDist := 6;
      MyMap.Routes[ 8 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 8 ].iDirFoot := DIR_DOWN;

      MyMap.Routes[ 9 ].Start.x := 7;
      MyMap.Routes[ 9 ].Start.y := 11;
      MyMap.Routes[ 9 ].iCorners := 2;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 9 ].Path[ 2 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 2 ].iDist := 9;
      MyMap.Routes[ 9 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 16;
      MyMap.Routes[ 10 ].Start.y := 45;
      MyMap.Routes[ 10 ].iCorners := 2;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 9;
      MyMap.Routes[ 10 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 10 ].Path[ 2 ].iDist := 6;
      MyMap.Routes[ 10 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 10 ].iDirFoot := DIR_UP;

    END;
  WRITE( MyFile, MyMap );


{ ---------------------------------------------------------------------------------------- MAP 07 - 'BROKENFRAME' ----- }
  WITH MyMap DO
    BEGIN
      sTitle           := 'Brokenframe';
      iInitialCookies  := 6;
      bRefreshCookies  := TRUE;


      clear_map( chMap );

	{ PAINT FRAME}

	  { CAGE }
      frame_rect( 28, 12, 71, 38, chMap );
      fill_rect( 29, 13, 70, 37, ASCII_CIRCLE, chMap );
      frame_rect( 31, 14, 68, 36, chMap );
      fill_rect( 32, 15, 67, 35, ASCII_SPACE, chMap );

	  { LINKS }
      fill_rect( 28, 18, 31, 23, ASCII_SPACE, chMap );

      set_xy( 28, 17, ASCII_DOUBLE_CORNER_NE, chMap );
      set_xy( 29, 17, ASCII_DOUBLE_LINE_HORZ, chMap );
      set_xy( 30, 17, ASCII_DOUBLE_LINE_HORZ, chMap );
      set_xy( 31, 17, ASCII_DOUBLE_CORNER_WN, chMap );

      set_xy( 28, 24, ASCII_DOUBLE_CORNER_ES, chMap );
      set_xy( 29, 24, ASCII_DOUBLE_LINE_HORZ, chMap );
      set_xy( 30, 24, ASCII_DOUBLE_LINE_HORZ, chMap );
      set_xy( 31, 24, ASCII_DOUBLE_CORNER_SW, chMap );

	  { OBEN }
      fill_rect( 46, 12, 53, 14, ASCII_SPACE, chMap );

      set_xy( 45, 12, ASCII_DOUBLE_CORNER_SW, chMap );
      set_xy( 45, 13, ASCII_DOUBLE_LINE_VERT, chMap );
      set_xy( 45, 14, ASCII_DOUBLE_CORNER_WN, chMap );
      set_xy( 54, 12, ASCII_DOUBLE_CORNER_ES, chMap );
      set_xy( 54, 13, ASCII_DOUBLE_LINE_VERT, chMap );
      set_xy( 54, 14, ASCII_DOUBLE_CORNER_NE, chMap );

	  { UNTEN }
      fill_rect( 37, 36, 44, 38, ASCII_SPACE, chMap );

      set_xy( 36, 36, ASCII_DOUBLE_CORNER_SW, chMap );
      set_xy( 36, 37, ASCII_DOUBLE_LINE_VERT, chMap );
      set_xy( 36, 38, ASCII_DOUBLE_CORNER_WN, chMap );
      set_xy( 45, 36, ASCII_DOUBLE_CORNER_ES, chMap );
      set_xy( 45, 37, ASCII_DOUBLE_LINE_VERT, chMap );
      set_xy( 45, 38, ASCII_DOUBLE_CORNER_NE, chMap );

	{ 1 PLAYER - INIT ONE SNAKE }
      MyMap.Routes[ 1 ].Start.x := 27;
      MyMap.Routes[ 1 ].Start.y := 18;
      MyMap.Routes[ 1 ].iCorners := 3;
      MyMap.Routes[ 1 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 1 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 1 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 1 ].Path[ 2 ].iDist := 3;
      MyMap.Routes[ 1 ].Path[ 3 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 1 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 1 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 1 ].iDirFoot := DIR_RIGHT;


	{ 2 PLAYERS - INIT TWO SNAKES }
      MyMap.Routes[ 2 ].Start.x := 27;
      MyMap.Routes[ 2 ].Start.y := 18;
      MyMap.Routes[ 2 ].iCorners := 3;
      MyMap.Routes[ 2 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 2 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 2 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 2 ].Path[ 2 ].iDist := 3;
      MyMap.Routes[ 2 ].Path[ 3 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 2 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 2 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 2 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 3 ].Start.x := 38;
      MyMap.Routes[ 3 ].Start.y := 39;
      MyMap.Routes[ 3 ].iCorners := 3;
      MyMap.Routes[ 3 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 3 ].Path[ 1 ].iDist := 4;
      MyMap.Routes[ 3 ].Path[ 2 ].iDir := DIR_LEFT;
      MyMap.Routes[ 3 ].Path[ 2 ].iDist := 5;
      MyMap.Routes[ 3 ].Path[ 3 ].iDir := DIR_UP;
      MyMap.Routes[ 3 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 3 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 3 ].iDirFoot := DIR_UP;


	{ 3 PLAYERS - INIT THREE SNAKES }
      MyMap.Routes[ 4 ].Start.x := 27;
      MyMap.Routes[ 4 ].Start.y := 18;
      MyMap.Routes[ 4 ].iCorners := 3;
      MyMap.Routes[ 4 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 4 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 4 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 4 ].Path[ 2 ].iDist := 3;
      MyMap.Routes[ 4 ].Path[ 3 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 4 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 4 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 4 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 5 ].Start.x := 38;
      MyMap.Routes[ 5 ].Start.y := 39;
      MyMap.Routes[ 5 ].iCorners := 3;
      MyMap.Routes[ 5 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 5 ].Path[ 1 ].iDist := 4;
      MyMap.Routes[ 5 ].Path[ 2 ].iDir := DIR_LEFT;
      MyMap.Routes[ 5 ].Path[ 2 ].iDist := 5;
      MyMap.Routes[ 5 ].Path[ 3 ].iDir := DIR_UP;
      MyMap.Routes[ 5 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 5 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 5 ].iDirFoot := DIR_UP;

      MyMap.Routes[ 6 ].Start.x := 52;
      MyMap.Routes[ 6 ].Start.y := 11;
      MyMap.Routes[ 6 ].iCorners := 2;
      MyMap.Routes[ 6 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 6 ].Path[ 1 ].iDist := 4;
      MyMap.Routes[ 6 ].Path[ 2 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 6 ].Path[ 2 ].iDist := 12;
      MyMap.Routes[ 6 ].iDirHead := DIR_UP;
      MyMap.Routes[ 6 ].iDirFoot := DIR_RIGHT;


	{ 4 PLAYERS - INIT FOUR SNAKES }
      MyMap.Routes[ 7 ].Start.x := 27;
      MyMap.Routes[ 7 ].Start.y := 18;
      MyMap.Routes[ 7 ].iCorners := 3;
      MyMap.Routes[ 7 ].Path[ 1 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 7 ].Path[ 1 ].iDist := 6;
      MyMap.Routes[ 7 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 7 ].Path[ 2 ].iDist := 3;
      MyMap.Routes[ 7 ].Path[ 3 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 7 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 7 ].iDirHead := DIR_LEFT;
      MyMap.Routes[ 7 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 8 ].Start.x := 38;
      MyMap.Routes[ 8 ].Start.y := 39;
      MyMap.Routes[ 8 ].iCorners := 3;
      MyMap.Routes[ 8 ].Path[ 1 ].iDir := DIR_UP;
      MyMap.Routes[ 8 ].Path[ 1 ].iDist := 4;
      MyMap.Routes[ 8 ].Path[ 2 ].iDir := DIR_LEFT;
      MyMap.Routes[ 8 ].Path[ 2 ].iDist := 5;
      MyMap.Routes[ 8 ].Path[ 3 ].iDir := DIR_UP;
      MyMap.Routes[ 8 ].Path[ 3 ].iDist := 7;
      MyMap.Routes[ 8 ].iDirHead := DIR_DOWN;
      MyMap.Routes[ 8 ].iDirFoot := DIR_UP;

      MyMap.Routes[ 9 ].Start.x := 52;
      MyMap.Routes[ 9 ].Start.y := 11;
      MyMap.Routes[ 9 ].iCorners := 2;
      MyMap.Routes[ 9 ].Path[ 1 ].iDir := DIR_DOWN;
      MyMap.Routes[ 9 ].Path[ 1 ].iDist := 4;
      MyMap.Routes[ 9 ].Path[ 2 ].iDir := DIR_RIGHT;
      MyMap.Routes[ 9 ].Path[ 2 ].iDist := 12;
      MyMap.Routes[ 9 ].iDirHead := DIR_UP;
      MyMap.Routes[ 9 ].iDirFoot := DIR_RIGHT;

      MyMap.Routes[ 10 ].Start.x := 45;
      MyMap.Routes[ 10 ].Start.y := 39;
      MyMap.Routes[ 10 ].iCorners := 2;
      MyMap.Routes[ 10 ].Path[ 1 ].iDir := DIR_LEFT;
      MyMap.Routes[ 10 ].Path[ 1 ].iDist := 2;
      MyMap.Routes[ 10 ].Path[ 2 ].iDir := DIR_UP;
      MyMap.Routes[ 10 ].Path[ 2 ].iDist := 14;
      MyMap.Routes[ 10 ].iDirHead := DIR_RIGHT;
      MyMap.Routes[ 10 ].iDirFoot := DIR_UP;


    END;

  WRITE( MyFile, MyMap );


{ ------------------------------------------------------------------------------------------ END - 'MAPS WRITTEN' ----- }
  CLRSCR;
  WRITE( 'Maps Written: ', FILEPOS( MyFile ) );
  DELAY( 750 );

  CLOSE( MyFile );

END.